MAKE(1)

NAVN
make - GNU's make-værktøj til vedligeholdelse af grupper af programmer

SYNOPSIS
make [TILVALG]... [MÅL]...

BESKRIVELSE

The make utility will determine automatically which pieces of a large program need to be recompiled, and issue the commands to recompile them. The manual describes the GNU implementation of make, which was written by Richard Stallman and Roland McGrath, and is currently maintained by Paul Smith. Our examples show C programs, since they are very common, but you can use make with any programming language whose compiler can be run with a shell command. In fact, make is not limited to programs. You can use it to describe any task where some files must be updated automatically from others whenever the others change.

For at kunne bruge make, skal du skrive en fil kaldet makefilen som beskriver forbindelserne mellem filerne i dit program og angiver kommandoerne til at opdatere hver fil. I et program er den kørbare fil typisk opdateret fra objektfiler, som igen er lavet ved at oversætte kildetekstfiler.

Når først der er en passende makefil, vil denne enkle kommado:

    make

suffices to perform all necessary recompilations. The make program uses the makefile description and the last-modification times of the files to decide which of the files need to be updated. For each of those files, it issues the commands recorded in the makefile.

make udfører kommandoer i makefilen for at opdatere et eller flere mål som typisk er programmer. Hvis der ikke er angivet et -f tilvalg, vil make kigge efter makefilerne GNUmakefile, makefile og Makefile i den rækkefølge.

Normalt bør du kalde din makefil enten makefile eller Makefile. (Vi anbefaler Makefile fordi det vil få en fremtrædende plads i begyndelsen af en katalogfilliste, i nærheden af andre vigtige filer såsom README). Det første tjekkede navn, GNUmakefile, er ikke anbefalet for de fleste makefiler. Du bør bruge det navn hvis du har en makefil som er specifik til GNU's make, og som ikke kan forstås af andre versioner af make. Hvis makefilen er `-', læses standard-inddata.

make opdaterer et mål hvis det afhænger af forudsatte filer som er blevet ændret efter at målet sidst var ændret, eller hvis målet ikke eksisterer.

TILVALG

-b, -m
    Disse ignoreres af hensyn til kompatibilitet med andre versioner af make.

-B, --always-make
    Skab alle mål betingelsesløst.

-C kat, --directory=kat
    Skift til kataloget kat før læsning af makefiler eller noget som helt andet. Hvis flere -C tilvalg er angivet, bliver hvert tolket relativt til det forrige: -C / -C etc svarer til -C /etc. Det bruges typisk ved rekursive kald af make.

-d  Udskriv fejlretningsinformation foruden den normale udførelse. Fejlretningsinformationen siger hvilke filer som kandiderer til at blive genlavet, hvilke filtider som sammenlignes med hvilke resultater, hvilke filer som faktisk behøver at blive genlavet, hvilke implicitte regler der undersøges, og hvilke der anvendes - alt interessant om hvordan make beslutter hvad der skal gøres.

--debug[=FLAG]
    Print debugging information in addition to normal processing. If the FLAGS are omitted, then the behavior is the same as if -d was specified. FLAGS may be a for all debugging output (same as using -d), b for basic debugging, v for more verbose basic debugging, i for showing implicit rules, j for details on invocation of commands, and m for debugging while remaking makefiles. Use n to disable all previous debugging flags.

-e, --environment-overrides
    Giv variable fra miljøet forrang for variable fra makefiler.

-E streng, --eval streng
    Interpret string using the eval function, before parsing any makefiles.

-f fil, --file=fil, --makefile=FIL
    Brug fil som makefile.

-i, --ignore-errors
    Ignorér alle fejl i kommandoer som udføres for at genlave filer.

-I kat, --include-dir=kat
    Angiver et katalog kat at søge inkluderede makefiler i. Hvis adskillige -I tilvalg bruges til angive adskillige kataloger, søges der i katalogerne i den angivne rækkefølge. Ulig argumenterne til andre af makes flag, må katalogerne givet med -I komme umiddelbart efter flaget: -Ikat er tilladt, såvel som -Ikat. Denne syntaks er tilladt for kompatibilitet med C's præprocessors -I tilvalg.

-j [jobs], --jobs[=jobs]
    Angiver antallet af job (kommandoer) til at køre samtidigt. Hvis der er mere end et -j tilvalg, er det sidste virksomt. Hvis -j tilvalget gives uden et argument, vil make ikke begrænse antallet af job som kan køre samtidigt.

-k, --keep-going
    Fortsæt så længe som muligt efter en fejl. Mens målet som fejlede, og dem som afhænger af det, ikke kan genlaves, kan andre ting som det afhænger af, alligevel udføres.

-l [last], --load-average[=last]
    Angiver at ingen nye job (kommandoer) skal startes hvis andre job kører, og middelbelastningen er last (et kommatal) eller højere. Uden et argument fjernes en foregående belastningsgrænse.

-L, --check-symlink-times
    Brug sidste mtime mellem symbolske lænker og mål.

-n, --just-print, --dry-run, --recon
    Print the commands that would be executed, but do not execute them (except in certain circumstances).

-o fil, --old-file=fil, --assume-old=fil
    Undlad at genlave filen fil selv hvis den er ældre end filer som den afhænger af, og undlad at genlave noget på grund af ændringer i fil. Basalt set behandles filen som værende ældst, og dens regler ignoreres.

-O[type], --output-sync[=type]
    When running multiple jobs in parallel with -j, ensure the output of each job is collected together rather than interspersed with output from other jobs. If type is not specified or is target the output from the entire recipe for each target is grouped together. If type is line the output from each command line within a recipe is grouped together. If type is recurse output from an entire recursive make is grouped together. If type is none output synchronization is disabled.

-p, --print-data-base
    Udskriv databasen (regler og varibelværdier) som stammer fra læsningen af makefiler; fortsæt så som sædvanligt eller som det ellers er angivet. Det udskriver også versionsinformationen fra -v valget (se nedenfor). For at udskrive databasen uden at prøve på at genlave nogen filer, brug make -p -f/dev/null.

-q, --question
    “forespørgselstilstand”. Kør ingen kommandoer, og udskriv intet; bare returnér en afslutningskode som er nul hvis de angivne mål allerede er ajour, og ellers ikkenul.

-r, --no-builtin-rules
    Udeluk brugen af indbyggede implicitte regler. Slet også den forudgivne suffiksliste for suffiksregler.

-R, --no-builtin-variables
    Don't define any built-in variables.

-s, --silent, --quiet
    Stille udførelse; udskriv ikke kommandoerne som de bliver udført.

--no-silent
    Cancel the effect of the -s option.

-S, --no-keep-going, --stop
    Cancel the effect of the -k option.

-t, --touch
    Rør filer (marker dem up to date uden egentlig at ændre dem) i stedet for at køre deres kommandoer. Det bruges til at foregive at kommandoerne blev udført for at narre fremtidige kald af make.

--trace
    Information about the disposition of each target is printed (why the target is being rebuilt and what commands are run to rebuild it).

-v, --version
    Print the version of the make program plus a copyright, a list of authors and a notice that there is no warranty.

-w, --print-directory
    Udskriv en besked med arbejdskataloget før og efter anden udførelsen. Det kan være nyttigt til at spore fejl i komplicerede indlejringer af rekursive make kommandoer.

--no-print-directory
    Slå -w fra, selv hvis det var slået til automatisk.

-W fil, --what-if=fil, --new-file=fil, --assume-new=fil
    Foregiv at målet fil lige er blevet ændret. Når det bruges med -n flaget, vil det vise hvad som ville ske hvis du ændrede den fil. Uden -n er det næsten det samme som at køre en touch kommando på den givne fil før kørslen af make, bortset fra at ændringstiden kun ændres i makes fantasi.

--warn-undefined-variables
    Advar når en udefineret variabel bruges.

AFSLUT-STATUS
GNU make exits with a status of zero if all makefiles were successfully parsed and no targets that were built failed. A status of one will be returned if the -q flag was used and make determines that a target needs to be rebuilt. A status of two will be returned if any errors were encountered.

SE OGSÅ
Hele dokumentationen for make bliver vedligeholdt som Texinfo manual. Hvis info and make programmerne er korrekt installeret på dit system vil komandoen

    info make

give dig adgang til den fulde manual.

FEJL
Se kapitlet "Problems and Bugs" i The GNU Make Manual .

FORFATTER
This manual page contributed by Dennis Morse of Stanford University. Further updates contributed by Mike Frysinger. It has been reworked by Roland McGrath. Maintained by Paul Smith.

OPHAVSRET
Copyright © 1992-1993, 1996-2020 Free Software Foundation, Inc. Denne fil er en del af GNU make.

GNU Make is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

GNU Make is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see http://www.gnu.org/licenses/.

OVERSÆTTELSE
De oversatte denne manual til dansk Byrial Ole Jensen <byrial@vip.cybercity.dk> Denne oversættelse er gratis dokumentation; læs GNU General Public License Version 3 (https://www.gnu.org/licenses/gpl-3.0.html) eller nyere for copyrightbetingelser. Der er INGEN ANSVAR. Hvis du støder på fejl i oversættelsen af ​​denne vejledning, skal du sende en e-mail til TODO.